macroScript Material_List
enabledIn:#("max", "viz", "vizr") 
category:"reForm Utilities" 
internalcategory:"Tools" 
ButtonText:"Material Lister 0.43"
tooltip:"Material Lister 0.43" 
Icon:#("Material_Modifiers",6)

-- SilentErrors:(Debug != True)
(
	clearListener()
	struct MatListerStruct (vrayMatRC, vrayMatList, standardMatList, multiMatList, MatInspectorSetup, \
							CreateMatRollout, MatInspectorFloater, MatInspectorListRollout, \
							materialsList, DeleCallback, MLUndoStr, DeleteCallback, \
							count, lbCount, matIndex, totalMatCount, getMatProp, setMatProp, enableRefreshBtn, \
							LineOffset, disableUIElements, UIControlList, enableUIElements,  \
							yOffset, LineOffset, showTexMap, showSpin, vrayWrapperMatList, vrayLightMatList, \
							compositeMatList, blendMatList, shellacMatList, mattMatList, morpherMatList, \
							showStandardmat, showVrayMat, showVrayWrapperMat, showVrayLightMat, \
							showMultiMat, showCompositeMat, showBlendMat, showShellacMat, showMattMat, showMorpherMat, \
							vraymatspace, editMatSlot, MatModeSetup, matMode, dropstandard, dropvray, dropvraywrap, \ 
							dropvraylight, dropcomposite, dropshellac, dropmatt, dropblend, dropmulti, curmatoff, \
							editmat, selectobjs, mly, mlyo, moredetail, refreshrollouts, vraymaps, matFilter )
							
	global MLister, MListerYOffset, MListerY, MListerYoff 
	MLister = MatListerStruct() 
	
	-- Strings for localisation
	MLister.MLUndoStr = "MaterialLister"
	
	local dialogUp = false
	
	-- End Strings
	
	-- Position to help localisation
	
	MListerYOffset = 0 -- -27
	MListerY = 15
	MListerYoff = -20
	MLister.mly = MListerY
	MLister.mlyo = MListerYoff
	MLister.yOffset = MListerYOffset 
	MLister.vraymatspace = 38
	MLister.LineOffset = 38
	MLister.showTexMap = true
	MLister.showSpin = true
	MLister.editmatslot = 1
	MLister.matmode = 1
	MLister.moredetail = false
	MLister.vraymaps = 1
	MLister.matFilter = 8

------------------------------
-------- Globals -------------
------------------------------




------------------------------
----- useful functions -------
------------------------------
	fn subtractFromArray myArray mySub =
	(
		tmpArray = #()
		for i in myArray do append tmpArray i
		for i in mySub do
		(
			itemNo = finditem tmpArray i
			local newArray = #()
			if itemNo != 0 do
			(
				for j in 1 to (itemNo-1) do append newArray tmpArray[j]
				for j in (itemNo+1) to tmpArray.count do append newArray tmpArray[j]
				tmpArray = newArray
			)
		)
		tmpArray
	)
	
	fn copyArray array1 = for i in array1 collect i
	
	fn SortNodeArrayByName myArray =
	(
		qsort myArray (fn myname v1 v2 = (if v1.name < v2.name then 0 else 1))
		myArray
	)
	
	fn disableUIElements array1 = for i in array1 do execute ("maxLightsRollout." + i as string + ".enabled = false")
	MLister.disableUIElements = disableUIElements
	
	fn enableRefreshBtn materialobj =
	(
		if (MLister.GetMatProp materialObj #useGlobalShadowSettings) == true do
		(
			MLister.MatInspectorSetup.BtnReload.Checked = true
		)
	)
	MLister.enableRefreshBtn = enableRefreshBtn
	
	fn getMatProp obj prop =
	(
		if (isProperty obj prop) and not (isProperty obj #delegate) then
			getProperty obj prop
		else 
			if isProperty obj #delegate then 
				if isProperty obj.delegate prop then
					getProperty obj.delegate prop
				else undefined
			else undefined
	)
	MLister.getMatProp = getMatProp
	
	fn setMatProp obj prop val =
	(
		if (isProperty obj prop) and not (isProperty obj #delegate) then
			setProperty obj prop val
		else
			if isProperty obj #delegate then 
				if isProperty obj.delegate prop then
					setProperty obj.delegate prop val
				else undefined
			else undefined
	)
	MLister.setMatProp = setMatProp
	
	fn isMaterialInUse mtl =
	(
		local foundSceneRef = false
		if superClassof mtl == material or superClassof mtl == textureMap do
		(
			local deps = refs.dependents mtl
			for i in deps while not foundSceneRef do
			(
				local c = classof i
				local sc = superclassof i
				local sid = i.superclassid
				-- exclude scene root, scene mtl lib, medit, materials, texturemaps, and texture map containers (used by std mtl to hold texmaps)
				foundSceneRef = c != Scene and c != MtlBaseLib and c != Material_Editor and sc != Material and sc != TextureMap and sid != 4224
			)
		)
		return foundSceneRef 	
	)


	-- edit material/map in editor
	fn editmat mat =
	(
		try
		(
			if (mat != undefined) do 
			(	
				if mateditor.isopen() == false do 
				(
					mateditor.open ()
				)
				activeslot = medit.getActiveMtlSlot()
				setMeditMaterial activeSlot mat
			)
		)
		catch (messagebox "There was a problem putting the material to the editor")
	)
	MLister.editmat = editmat
	--remove materials/maps from viewport of supplied material/map
	-- local curmatoff
	fn curmatoff mat = 
	(
		if (mat != undefined) then 
		(
			local a
			
			if (classof mat == standardmaterial) then
			(
				showtexturemap mat off
				a = (getsubanimnames mat) 
				for i = 1 to a.count do 
				(
					print i
					print (superclassof mat[1][i].value)
					if (superclassof mat[1][i].value == texturemap)  then 
					(
						print "something worked"
						print mat
						print mat[1][i].value
						showtexturemap mat mat[1][i].value off
					)
					else undefined
				)
			)
			else undefined
			
			if (classof mat == vraymtl) then
			(
				a = (getsubanimnames mat) 
				for i = 1 to a.count do 
				(
					print (superclassof mat[i].value)
					if (superclassof mat[i].value == texturemap)  then 
					(
						showtexturemap mat mat[i].value off
					)
					else undefined
				)
			)
			else undefined
		)
		else undefined
	) -- end of function
	MLister.curmatoff = curmatoff
	
	fn selectObjs mat = 
	(
		try 
		(
			if (mat != undefined) do 
			(
				local selectionlist = #()
				for loop in $geometry do
				(
					if (loop.material != undefined) do (if loop.material == mat do append selectionlist loop)	
				)
				select selectionlist
			)
		)
		catch (messagebox "There was a problem selecting objects with the currently selected material")
	)
	MLister.selectobjs = selectObjs
		
	fn parseScene mycollection = 
	(
		gc
		vrayMats = #(#vraymtl)
		vrayWrapperMats = #(#vrayMtlWrapper)
		vrayLightMats = #(#vrayLightMtl)
		standardMats = #(#standardmaterial)
		multiMats = #(#multimaterial)
		compositeMats = #(#compositeMaterial)
		blendMats = #(#blend)
		shellacMats = #(#shellac)
		mattMats = #(#matteShadow)
		morpherMats = #(#morphermaterial)
		
		-------------------------------------------------------
		--------------------- Scene Parser --------------------
		-------------------------------------------------------
		
		sceneMats = #()
		for m in mycollection do 
		(	
			-- add all materials
			append sceneMats m
			
			-- if materials is multi-subobject, add sub-materials
			if classof m == multimaterial do
			(	
				for n in m do
				(
					-- check if already listed
					if (finditem scenemats n != true) do append sceneMats n
				)
			)		

			-- if materials is lighting Override, add sub-materials
			if classof m == Advanced_Lighting_Override do
			(	
				append sceneMats m.baseMaterial
			)	

			-- if materials is blend, add sub-materials
			if classof m == blend do
			(	
				append sceneMats m.map1 
				append sceneMats m.map2

			)	
			
			-- if materials is shelac, add sub-materials
			if classof m == shellac do
			(	
				append sceneMats m.shellacMtl1 
				append sceneMats m.shellacMtl2 

			)	
			
			-- if materials is composite, add sub-materials
			if classof m == composite do
			(	
				for x=1 to 9 do append sceneMats m.materiallist[x]	
			)	
			-- if materials is vraywrapper, add sub-materials
			if classof m == vraymtlwrapper do
			(	
				append sceneMats m.basemtl 	
			)	



		)
		
		
		--delete duplicate materials/maps
		for c = 1 to scenemats.count do
		(
			for j = scenemats.count to c+1 by -1 do
			(
				if (scenemats[c]== scenemats[j]) do
				(
					deleteItem sceneMats j
				)
			)
		)
		
		-- declare arrays for each material type
		sceneVrayMats = #()
		sceneStandardMats = #()
		sceneMultiMats = #()
		sceneVrayWrapperMats = #()
		sceneVrayLightMats = #()
		sceneCompositeMats = #()
		sceneBlendMats = #()
		sceneShellacMats = #()
		sceneMattMats = #()
		sceneMorpherMats = #()
		
		-- add materials to material arrays. Only deal with materials that match the filter.
		for i in SceneMats do
		(	
			MatClass = ((classof i) as string) as name
			if findItem vrayMats MatClass != 0 AND Mlister.matfilter == 8  do append sceneVrayMats i
			if findItem standardMats MatClass != 0 AND Mlister.matfilter == 6 do append SceneStandardMats i
			if findItem multiMats MatClass != 0 AND Mlister.matfilter == 4 do append SceneMultiMats i
			if findItem vrayWrapperMats MatClass != 0 AND Mlister.matfilter == 9 do append sceneVrayWrapperMats i
			if findItem vrayLightMats MatClass != 0 AND Mlister.matfilter == 7 do append sceneVrayLightMats i
			if findItem compositeMats MatClass != 0 AND Mlister.matfilter == 2 do append sceneCompositeMats i
			if findItem blendMats MatClass != 0 AND Mlister.matfilter == 1 do append sceneBlendMats i
			if findItem shellacMats MatClass != 0 AND Mlister.matfilter == 5 do append sceneShellacMats i
			if findItem mattMats MatClass != 0 AND Mlister.matfilter == 3 do append sceneMattMats i
			if findItem morpherMats MatClass != 0 AND Mlister.matfilter == 10 do append sceneMorpherMats i	
		)
		
		
		-- fill temp arrays
		tmpParser = #( \
			tmpsceneVrayMats  = copyArray sceneVrayMats, \
			tmpSceneStandardMats   = copyArray SceneStandardMats , \
			tmpSceneMultiMats   = copyArray SceneMultiMats , \
			tmpsceneVrayWrapperMats   = copyArray sceneVrayWrapperMats , \
			tmpsceneVrayLightMats  = copyArray sceneVrayLightMats , \
			tmpsceneCompositeMats   = copyArray sceneCompositeMats , \
			tmpsceneBlendMats   = copyArray sceneBlendMats , \
			tmpsceneShellacMats   = copyArray sceneShellacMats , \
			tmpsceneMattMats   = copyArray sceneMattMats , \
			tmpsceneMorpherMats   = copyArray sceneMorpherMats  \
			)
		
			
	
		ListParser = #( \
			MLister.vrayMatList = #(), \
			MLister.standardMatList = #(), \
			MLister.multiMatList = #(), \
			MLister.vrayWrapperMatList = #(), \
			MLister.vrayLightMatList = #(), \
			MLister.compositeMatList = #(), \
			MLister.blendMatList = #(), \
			MLister.shellacMatList = #(), \
			MLister.mattMatList = #(), \
			MLister.morpherMatList = #() \
		)
		
		MLister.vrayMatList = scenevraymats
		MLister.standardMatList = scenestandardmats
		MLister.multiMatList = scenemultimats
		MLister.vrayWrapperMatlist = scenevraywrappermats
		MLister.vrayLightMatList = scenevraylightmats
		MLister.compositeMatList = scenecompositemats
		MLister.blendMatList = sceneblendmats
		MLister.shellacMatList = sceneshellacmats
		MLister.mattMatList = scenemattmats
		MLister.morpherMatList = scenemorphermats
		
		MLister.totalMatCount = MLister.vrayMatList.count + \
			MLister.standardMatList.count + \
			MLister.multiMatList.count + \
			MLister.vrayWrapperMatlist.count + \
			MLister.vrayLightMatList.count + \
			MLister.compositeMatList.count + \
			MLister.blendMatList.count + \
			MLister.shellacMatList.count + \
			MLister.mattMatList.count + \
			MLister.morpherMatList.count
	)
	
	fn refreshrollouts = 
	(
		try (removerollout MLister.MatInspectorListRollout MLister.MatInspectorFloater) catch()
		MLister.MatInspectorListRollout = MLister.CreateMatRollout (sceneMaterials)
		if MLister.MatInspectorListRollout != undefined do
			addRollout MLister.MatInspectorListRollout MLister.MatInspectorFloater
			
		
					
		MLister.vrayMatRC = undefined		
	) -- END REFRESH ROLLOUTS -- 
	MLister.refreshrollouts = refreshrollouts 
	
	
	
	------------------------------
	-----  main function ---------
	------------------------------
	
	local CreateMatRollout
	fn CreateMatRollout myCollection =
	(	
			
		MLister.MatInspectorSetup.pbar.visible = true
		
		-------------------------------------------------------
		---------- BuildControls and rollouts------------------
		-------------------------------------------------------
		
		
		MLister.vrayMatRC = rolloutCreator "vrayMatsRollout" "Materials"
		MLister.vrayMatRC.begin()
		MLister.count = 1
		MLister.lbCount = 1
		MLister.MatIndex = #()
		MLister.UIControlList = #(#(), #())
			
		-------------------------------------------------------
		---------- Routine to add Column Headings -------------
		-------------------------------------------------------
	
		fn WriteTitle mat:"standard" = 
		(
			
			local lbName
			
			fn lbName = 
			(
				if MLister.lbCount == undefined do MLister.lbCount = 1
				MLister.lbCount += 1
				("LB" + MLister.lbCount as string) as name
			) -- end function lbName
			
			local labelOffset = -3
		 	if mat == "vray" do (
				MLister.vrayMatRC.addControl #radiobuttons (("vrayMaps" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"Diffuse\", \"Reflect\", \"Refract\", \"Translucent\", \"Bump\",  \"Displace\", \"Opacity\",\"Environment\", \"Options\") default:MLister.vraymaps offset:[85,-21] align:#left width:100 height:15")
					MLister.vrayMatRC.addHandler (("vrayMaps" + MLister.count as string) as name) #'changed v_map' filter:on \
						codeStr:("MLister.vraymaps = vrayMaps" + MLister.count as string + ".state \n MLister.refreshRollouts()" )
				
				if MLister.vraymaps == 1 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Diffuse Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 2 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refl.Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "hGl." paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "rGl." paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "SubD." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Depth." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refl. Gloss Map" paramStr:(" offset:[590,-20] align:#LEFT height:15")
				)
				if MLister.vraymaps == 3 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refr.Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "rGl." paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "IOR" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "SubD." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Depth." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refr. Gloss Map" paramStr:(" offset:[590,-20] align:#LEFT height:15")
				)
				if MLister.vraymaps == 4 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "TrCol." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Thck." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "L.Mult." paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Sc.Co" paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Fwd/Bk" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "FogCol." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "FogMult." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Aff.Sh." paramStr:(" offset:[590,-20] align:#LEFT height:15")

				)
				if MLister.vraymaps == 5 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Bump Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 6 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Displace Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 7 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Opacity Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 8 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Env. Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
					if MLister.vraymaps == 9 do (
					MLister.vrayMatRC.addControl #label (lbName()) "BRDF" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Aniso." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Rot." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "T.Refl" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "T.Refr" paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "CutO" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "DS" paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "RBS" paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "UI" paramStr:(" offset:[590,-20] align:#LEFT height:15")

				)
				
			)
			
			if mat == "standard" do (
				MLister.vrayMatRC.addControl #radiobuttons (("vrayMaps" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"B.Params\", \"Diff.\", \"Ambient.\", \"Spec.\", \"S.Illum.\", \"Opacity\", \"Bump\", \"Refl.\", \"Refr.\", \"Displ.\", \"E.Params\") default:MLister.vraymaps offset:[85,-21] align:#left width:100 height:15")
					MLister.vrayMatRC.addHandler (("vrayMaps" + MLister.count as string) as name) #'changed v_map' filter:on \
						codeStr:("MLister.vraymaps = vrayMaps" + MLister.count as string + ".state \n MLister.refreshRollouts()" )
				
				if MLister.vraymaps == 1 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Diffuse Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 2 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refl.Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "hGl." paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "rGl." paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "SubD." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Depth." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refl. Gloss Map" paramStr:(" offset:[590,-20] align:#LEFT height:15")
				)
				if MLister.vraymaps == 3 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Col." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refr.Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "rGl." paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "IOR" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "SubD." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Depth." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Refr. Gloss Map" paramStr:(" offset:[590,-20] align:#LEFT height:15")
				)
				if MLister.vraymaps == 4 do (
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "TrCol." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Thck." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "L.Mult." paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Sc.Co" paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Fwd/Bk" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "FogCol." paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "FogMult." paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Aff.Sh." paramStr:(" offset:[590,-20] align:#LEFT height:15")

				)
				if MLister.vraymaps == 5 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Bump Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 6 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Displace Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 7 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Opacity Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
				if MLister.vraymaps == 8 do (
					
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Env. Map" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					
				)
					if MLister.vraymaps == 9 do (
					MLister.vrayMatRC.addControl #label (lbName()) "BRDF" paramStr:(" offset:[25,0] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Aniso." paramStr:(" offset:[170,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "Rot." paramStr:(" offset:[200,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "T.Refl" paramStr:(" offset:[280,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "T.Refr" paramStr:(" offset:[373,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "CutO" paramStr:(" offset:[411,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "DS" paramStr:(" offset:[440,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "RBS" paramStr:(" offset:[503,-20] align:#LEFT height:15")
					MLister.vrayMatRC.addControl #label (lbName()) "UI" paramStr:(" offset:[590,-20] align:#LEFT height:15")

				)
				
			)
			
			if mat == "multi" do (
				MLister.vrayMatRC.addControl #label (lbName()) "Name:" paramStr:(" offset:[-5,0] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "No." paramStr:(" offset:[129,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M1" paramStr:(" offset:[159,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M3" paramStr:(" offset:[192,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M4" paramStr:(" offset:[220,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M5" paramStr:(" offset:[260,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M6" paramStr:(" offset:[300,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M7" paramStr:(" offset:[330,-20] align:#left width:40 height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "M8" paramStr:(" offset:[360,-20] align:#left width:40 height:15")
			)	
			if mat == "composite" do (

			)	
			if mat == "blend" do (
				MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Material 1" paramStr:(" offset:[180,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Material 2" paramStr:(" offset:[300,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Mask" paramStr:(" offset:[420,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Amnt." paramStr:(" offset:[515,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Interactive" paramStr:(" offset:[600,-20] align:#LEFT height:15")
			)	
			if mat == "matt" do (
					MLister.vrayMatRC.addControl #radiobuttons (("vrayMaps" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"Matt\", \"Atmosphere\", \"Shadow\", \"Reflection\") default:MLister.vraymaps offset:[85,-21] align:#left width:100 height:15")
					MLister.vrayMatRC.addHandler (("vrayMaps" + MLister.count as string) as name) #'changed v_map' filter:on \
						codeStr:("MLister.vraymaps = vrayMaps" + MLister.count as string + ".state \n MLister.refreshRollouts()" )
							
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					case of 
					(
					(MLister.vraymaps==1):	MLister.vrayMatRC.addControl #label (lbName()) "Matte Parameters" paramStr:(" offset:[165,-22] align:#LEFT height:15")
					(MLister.vraymaps==2):	MLister.vrayMatRC.addControl #label (lbName()) "Atmosphere Parameters" paramStr:(" offset:[165,-22] align:#LEFT height:15")
					(MLister.vraymaps==3):	MLister.vrayMatRC.addControl #label (lbName()) "Shadow Parameters" paramStr:(" offset:[165,-22] align:#LEFT height:15")
					(MLister.vraymaps==4):	MLister.vrayMatRC.addControl #label (lbName()) "Reflection Parameters" paramStr:(" offset:[165,-22] align:#LEFT height:15")

					)
			)
			if mat == "shellac" do (
				MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[0,0] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Base Material" paramStr:(" offset:[220,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Shallac Material" paramStr:(" offset:[420,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Shellac Colour Blend" paramStr:(" offset:[565,-20] align:#LEFT height:15")
			)

			if mat == "vraylight" do (
				MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[0,0] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Colour" paramStr:(" offset:[165,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Multiplier" paramStr:(" offset:[245,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "2-sided" paramStr:(" offset:[335,-20] align:#LEFT height:15")
				MLister.vrayMatRC.addControl #label (lbName()) "Texmap" paramStr:(" offset:[475,-20] align:#LEFT height:15")

			)

			if mat == "vraywrapper" do (
					MLister.vrayMatRC.addControl #radiobuttons (("vrayMaps" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"Base Properties\", \"Matte Properties\") default:MLister.vraymaps offset:[85,-21] align:#left width:100 height:15")
					MLister.vrayMatRC.addHandler (("vrayMaps" + MLister.count as string) as name) #'changed v_map' filter:on \
						codeStr:("MLister.vraymaps = vrayMaps" + MLister.count as string + ".state \n MLister.refreshRollouts()" )
							
					MLister.vrayMatRC.addControl #label (lbName()) "Name" paramStr:(" offset:[25,0] align:#LEFT height:15")
					case of 
					(
					(MLister.vraymaps==1):	(
						MLister.vrayMatRC.addControl #label (lbName()) "Base Material" paramStr:(" offset:[175,-22] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Generate GI" paramStr:(" offset:[305,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Receive GI" paramStr:(" offset:[405,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Caustics Mult." paramStr:(" offset:[500,-20] align:#LEFT height:15")

						
						)
					(MLister.vraymaps==2):	(
						MLister.vrayMatRC.addControl #label (lbName()) "Matte S." paramStr:(" offset:[180,-22] align:#LEFT height:15")
						--MLister.vrayMatRC.addControl #label (lbName()) "Alpha Contrib." paramStr:(" offset:[165,-22] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Colour" paramStr:(" offset:[355,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Alpha Contrib." paramStr:(" offset:[235,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Brightness" paramStr:(" offset:[405,-20] align:#LEFT height:15")

						MLister.vrayMatRC.addControl #label (lbName()) "Reflection." paramStr:(" offset:[475,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "Refraction" paramStr:(" offset:[545,-20] align:#LEFT height:15")
						MLister.vrayMatRC.addControl #label (lbName()) "GI." paramStr:(" offset:[635,-20] align:#LEFT height:15")
						
						)
					)
			)

				

		




		) -- END OF FN WRITETITLE			
			
		-------------------------------------------------------
		---------- routine to add material controls -----------
		-------------------------------------------------------
	
		fn CreateControls = 
		(
			-----------------------
			--- LOCAL FUNCTIONS ---
			-----------------------
			
			local lbName
				
			fn lbName = 
			(
				if MLister.lbCount == undefined do MLister.lbCount = 1
				MLister.lbCount += 1
				("LB" + MLister.lbCount as string) as name
			) -- end function lbName
			
			
			
			local isUsingEdittextOffset = 0, editTextSize = 75
			local isMatSelected = false
			--for i in Mlister.MatIndex[MLister.count] where (not isMatSelected) do isMatSelected = i.isSelected
				
			MLister.UIControlList[1][MLister.count] = MLister.MatIndex[MLister.count][1]
			MLister.UIControlList[2][MLister.count] = #()
				
			-----------------------------------------
			-----------------------------------------
			if (Mlister.matmode == 1) do  -- SIMPLE MODE CONTROLLERS -- 
			(
				
				
				----- STANDARD MATERIAL CONTROLLERS ---------
				
				if (classof MLister.matIndex[Mlister.count] == standardmaterial) Do 
				(
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("SMatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10,0] align:#left width:120 height:16 ")
					MLister.vrayMatRC.addHandler (("SMatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
				
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112,-19] align:#left " + \
							" width:10 height:13 filter:on tooltip:\"select objects with this material\" ")
							
							
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' \
							codeStr:(" MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
				
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
					
					MLister.vrayMatRC.addControl #Button (("SMatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124,-18] align:#left" + " width:10 height:13 filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("SMatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if $.material != undefined do $.material = MLister.matIndex[" + MLister.count as string + "])catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl#Button (("SMatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136,-18] align:#left" + " width:10 height:13 filter:on tooltip:\"Edit material in material editor\" ") 
						
					MLister.vrayMatRC.addHandler (("SMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials/maps in viewport --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("SViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148,-18] align:#left width:10 height:13 filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("SViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")	
			
				
				
				
				) -- END OF STANDARD MATERIAL CONTROLS
				
				
				----------------------------
				-- VRAY MATERIAL CONTROLS --
				----------------------------
				
				if (classof MLister.matIndex[MLister.count] == VRayMtl) Do 
				(
					
					----------------------------
					---- Default Parameters ----
					----------------------------
					
					----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("MatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(MLister.moredetail as string) + " offset:[-14,-3] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					MLister.vrayMatRC.addHandler (("MatSel" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.moredetail = state \n print MLister.moredetail \n MLister.refreshrollouts()")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10," + MLister.mlyo as string + "] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matindex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
			
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					

					
					--------------------------------------
					--------- Diffuse Parameters ---------
					--------------------------------------

					if MLister.vraymaps == 1 do (

					---------------------------
					-- Diffuse Colour Picker --
					---------------------------
					
					MLister.vrayMatRC.addControl #colorPicker (("MatDiffCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[160," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #diffuse) as string + \
						" width:35 height:" + MLister.mly as string + " fieldWidth:16")
					MLister.vrayMatRC.addHandler (("MatDiffCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #diffuse val")
					
					---------------------------------
					-- Diffuse Map Amount Spinner ---
					---------------------------------
					if (MLister.matIndex[mlister.count].texmap_diffuse_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_diffuse_multiplier.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("MatDiffSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_diffuse_multiplier as string + \ 
						"] offset:[-275," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:1 type:#integer tooltip:\"Diffuse Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_diffuse_multiplier.controller")
					
					---------------------------
					-- Diffuse Map Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("diffTog" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_diffuse_on align:#left width:15 height:13 filter:on tooltip:\"Use Diffusemap\" ")
					
					MLister.vrayMatRC.addHandler (("diffTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_diffuse_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_diffuse_on = off")
	
					-----------------------------
					-- Diffuse Colour Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("MatDiffMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_diffuse) as string) \
						paramStr:("tooltip:\"Select Diffuse Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatDiffMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_diffuse = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
									
					--------------------------------------------------
					-- Edit diffuse map material in material editor --
					--------------------------------------------------
					MLister.vrayMatRC.addControl #Button (("DifMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("DifMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_diffuse")
					
					)
					--------------------------------------
					------- End Diffuse Parameters -------
					--------------------------------------
					
					--------------------------------------
					--------- Diffuse Parameters ---------
					--------------------------------------

					if MLister.vraymaps == 2 do (

					------------------------------
					----- Reflection Colour ------
					------------------------------

					MLister.vrayMatRC.addControl #colorPicker (("MatReflCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[160," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #reflection) as string + \
						" width:35 align: #left height:" + MLister.mly as string + " fieldWidth:15")
					MLister.vrayMatRC.addHandler (("MatReflCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #reflection val")
					
					-------------------------------------
					-- reflection Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_reflection_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_reflection_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatReflSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_reflection_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[-275," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"Reflection Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_reflection_multiplier.controller height:14")
					
					---------------------------
					-- Reflection Map Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("reflTog" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_reflection_on align:#left width:15 height:13 filter:on tooltip:\"Use Reflection Map\" ")
					
					MLister.vrayMatRC.addHandler (("reflTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_reflection_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_reflection_on = off")
	
					
					-----------------------------------------------------
					-- Edit reflection map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("ReflMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit reflection_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("ReflMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_reflection)catch (messagebox@No reflectionmap defined@)")
	
					---------------------------------
					-- Reflection Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatReflMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_reflection) as string) \
						paramStr:("tooltip:\"Select Reflection Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatReflMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_reflection = texmap \n" + ("MatReflMap" + MLister.count as string) + ".text = texmap as string")
						
					---------------------------------
					--Highlight Glossiness Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].hilight_glossiness.controller == undefined) do MLister.matIndex[mlister.count].hilight_glossiness.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("MatHiGSpin" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].hilight_glossiness as string + \ 
						"] offset:[-259," + MLister.mlyo as string + "] fieldwidth:25 scale:.01 type:#float tooltip:\"Highlight Glossiness\" controller:MLister.matIndex[" + MLister.count as string + \
						"].hilight_glossiness.controller height:" + MLister.mly as string + "")

					
					---------------------------------
					--Reflection Glossiness Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].reflection_glossiness.controller == undefined) do MLister.matIndex[mlister.count].reflection_glossiness.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("MatReflGSpin" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].reflection_glossiness as string + \ 
						"] offset:[-221," + MLister.mlyo as string + "] fieldwidth:25 scale:.01 type:#float tooltip:\"Reflection Glossiness\" controller:MLister.matIndex[" + MLister.count as string + \
						"].reflection_glossiness.controller height:" + MLister.mly as string + "")
				
					-----------------------------------------
					--Reflection Glossiness Subdivs Spinner--
					-----------------------------------------
					
					MLister.vrayMatRC.addControl #spinner (("MatReflGSubdivs" + MLister.count as string) as name) "" paramStr:(" range:[0,40," + MLister.MatIndex[MLister.count].reflection_subdivs as string + "] offset:[438," + MLister.mlyo as string + "] fieldwidth:24 align:#left scale:1 tooltip:\"Reflection Subdivs\" type:#integer")
					MLister.vrayMatRC.addHandler (("MatReflGSubdivs" + MLister.count as string) as name) #'changed ReflSub' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].reflection_subdivs = ReflSub")
				
		
					---------------------------------
					-- Reflection Fresnel Toggle ----
					---------------------------------

					
					MLister.vrayMatRC.addControl #checkbutton (("MatReflfres" + MLister.count as string) as name) "F" paramStr:(" offset:[475," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].reflection_fresnel align:#left width:14 height:14 filter:on tooltip:\"Reflection Fresnel Toggle\" ")
					
					MLister.vrayMatRC.addHandler (("MatReflfres" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].reflection_fresnel = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].reflection_fresnel = false")
	
					-------------------------------
					-- reflection Interpolation ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbutton (("ReflInterp" + MLister.count as string) as name) "I" paramStr:(" offset:[490," + (MLister.mlyo + 1) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].reflection_useInterpolation align:#left width:14 height:14 filter:on tooltip:\"Reflection Interpolation\" ")
					
					MLister.vrayMatRC.addHandler (("ReflInterp" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].reflection_useinterpolation = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].reflection_useinterpolation = false")
	
					-----------------------------------------
					--Reflection Max Depth Spinner--
					-----------------------------------------
					
					MLister.vrayMatRC.addControl #spinner (("MatRefld" + MLister.count as string) as name) "" paramStr:(" range:[0,40," + MLister.MatIndex[MLister.count].reflection_maxDepth as string + "] offset:[505," + MLister.mlyo as string + "] fieldwidth:24 align:#left scale:1 tooltip:\"Reflection Subdivs\" type:#integer")
					MLister.vrayMatRC.addHandler (("MatRefld" + MLister.count as string) as name) #'changed ReflD' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].reflection_maxDepth = ReflD")
					
					-------------------------------------
					-- reflection Glossiness Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_reflectionGlossiness_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_reflectionGlossiness_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatGReflSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_reflectionGlossiness_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[67," + MLister.mlyo as string + "] width:39 scale:1 type:#integer tooltip:\"reflectionGlossiness Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_reflectionGlossiness_multiplier.controller height:14")
						
					
					---------------------------------
					-- Reflection Glossiness Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatGReflMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_reflectionGlossiness) as string) \
						paramStr:("tooltip:\"Select Reflection Glossiness Map\" align:#left height:" + MLister.mly as string + " width:80 offset:[582," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatGReflMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_reflectionGlossiness = texmap \n" + ("MatGReflMap" + MLister.count as string) + ".text = texmap as string")
					
					-----------------------------------------------------
					-- Edit reflection Glossiness map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("ReflGMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[664," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit reflection glossiness map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("ReflGMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_reflectionGlossiness)catch (messagebox@No reflection glossiness defined@)")
	
				
					

					
					) -- end reflection IF

					if MLister.vraymaps == 3 do (

					------------------------------
					----- refraction Colour ------
					------------------------------

					MLister.vrayMatRC.addControl #colorPicker (("MatrefrCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[160," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #refraction) as string + \
						" width:35 align: #left height:" + MLister.mly as string + " fieldWidth:15")
					MLister.vrayMatRC.addHandler (("MatrefrCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #refraction val")
					
					-------------------------------------
					-- refraction Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_refraction_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_refraction_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatrefrSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_refraction_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[-275," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"refraction Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_refraction_multiplier.controller height:14")
					
					---------------------------
					-- Diffuse Map Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("refrTog" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_refraction_on align:#left width:15 height:13 filter:on tooltip:\"Use refraction Map\" ")
					
					MLister.vrayMatRC.addHandler (("refrTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_refraction_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_refraction_on = off")
	
					
					-----------------------------------------------------
					-- Edit refraction map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("refrMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit refraction_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("refrMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_refraction)catch (messagebox@No refractionmap defined@)")
	
					---------------------------------
					-- refraction Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatrefrMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_refraction) as string) \
						paramStr:("tooltip:\"Select refraction Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatrefrMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_refraction = texmap \n" + ("MatrefrMap" + MLister.count as string) + ".text = texmap as string")
						
					
					
					---------------------------------
					--refraction Glossiness Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].refraction_glossiness.controller == undefined) do MLister.matIndex[mlister.count].refraction_glossiness.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("MatrefrGSpin" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].refraction_glossiness as string + \ 
						"] offset:[-259," + MLister.mlyo as string + "] fieldwidth:25 scale:.01 type:#float tooltip:\"refraction Glossiness\" controller:MLister.matIndex[" + MLister.count as string + \
						"].refraction_glossiness.controller height:" + MLister.mly as string + "")
						
					
					---------------------------------
					--refraction IOR Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].refraction_ior.controller == undefined) do MLister.matIndex[mlister.count].refraction_ior.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("MatrefriorGSpin" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].refraction_ior as string + \ 
						"] offset:[-221," + MLister.mlyo as string + "] fieldwidth:25 scale:.01 type:#float tooltip:\"refraction IOR\" controller:MLister.matIndex[" + MLister.count as string + \
						"].refraction_ior.controller height:" + MLister.mly as string + "")
				
					-----------------------------------------
					--refraction Glossiness Subdivs Spinner--
					-----------------------------------------
					
					MLister.vrayMatRC.addControl #spinner (("MatrefrGSubdivs" + MLister.count as string) as name) "" paramStr:(" range:[0,40," + MLister.MatIndex[MLister.count].refraction_subdivs as string + "] offset:[438," + MLister.mlyo as string + "] fieldwidth:24 align:#left scale:1 tooltip:\"refraction Subdivs\" type:#integer")
					MLister.vrayMatRC.addHandler (("MatrefrGSubdivs" + MLister.count as string) as name) #'changed refrSub' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].refraction_subdivs = refrSub")
				
		
					
					-------------------------------
					-- refraction Interpolation ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbutton (("refrInterp" + MLister.count as string) as name) "I" paramStr:(" offset:[490," + (MLister.mlyo + 1) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].refraction_useInterpolation align:#left width:14 height:14 filter:on tooltip:\"refraction Interpolation\" ")
					
					MLister.vrayMatRC.addHandler (("refrInterp" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].refraction_useinterpolation = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].refraction_useinterpolation = false")
	
					-----------------------------------------
					--refraction Max Depth Spinner--
					-----------------------------------------
					
					MLister.vrayMatRC.addControl #spinner (("Matrefrd" + MLister.count as string) as name) "" paramStr:(" range:[0,40," + MLister.MatIndex[MLister.count].refraction_maxDepth as string + "] offset:[505," + MLister.mlyo as string + "] fieldwidth:24 align:#left scale:1 tooltip:\"refraction Subdivs\" type:#integer")
					MLister.vrayMatRC.addHandler (("Matrefrd" + MLister.count as string) as name) #'changed refrD' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].refraction_maxDepth = refrD")
					
					------------------------------------------------
					-- refraction Glossiness Map Amount Spinner ----
					------------------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_refractionGlossiness_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_refractionGlossiness_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatGrefrSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_refractionGlossiness_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[67," + MLister.mlyo as string + "] width:39 scale:1 type:#integer tooltip:\"refractionGlossiness Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_refractionGlossiness_multiplier.controller height:14")
						
					-----------------------------------------------------
					-- Edit refraction Glossiness map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("refrGMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[664," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit refraction glossiness map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("refrGMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_refractionGlossiness)catch (messagebox@No refraction glossiness defined@)")
	
					---------------------------------
					-- refraction Glossiness Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatGrefrMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_refractionGlossiness) as string) \
						paramStr:("tooltip:\"Select refraction Glossiness Map\" align:#left height:" + MLister.mly as string + " width:80 offset:[582," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatGrefrMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_refractionGlossiness = texmap \n" + ("MatGrefrMap" + MLister.count as string) + ".text = texmap as string")
						
				
					

					
					) -- end refraction IF

					------------------------------
					----- Translucence parameters------
					------------------------------
					
					if MLister.vraymaps == 4 do (
					
					-------------------------------
					------- trans toggle --------
					-------------------------------
				
					--MLister.vrayMatRC.addControl #checkbox (("transTogg" + MLister.count as string) as name) "" paramStr:(" offset:[160," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].translucency_on align:#left width:15 height:13 filter:on tooltip:\"Translucency Toggle\" ")
					
					--MLister.vrayMatRC.addHandler (("transTogg" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].translucency_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].translucency_on = off")
	
					------------------------------
					----- trans Colour ------
					------------------------------

					MLister.vrayMatRC.addControl #colorPicker (("MattranCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[175," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #translucency_color) as string + \
						" width:35 align: #left height:" + MLister.mly as string + " fieldWidth:15")
					MLister.vrayMatRC.addHandler (("MattranCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #translucency_color val")
					-------------------------------------
					-- Trans Thickness Spinner ----
					-------------------------------------
					
					MLister.vrayMatRC.addControl #spinner (("MatTransThSlide" + MLister.count as string) as name) "" \
						paramStr:(" offset:[190," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #translucency_thickness) as string + \
						" scale:1 range: [0,999999,"+ MLister.Matindex[MLister.count].translucency_thickness as string + "] type:#integer tooltip:\"Translucency Thickness Amount\" align: #left height:" + MLister.mly as string + " fieldWidth:45")
					MLister.vrayMatRC.addHandler (("MattranCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #translucency_thickness val")

					-- if (MLister.matIndex[mlister.count].translucency_thickness.controller == undefined) do MLister.matIndex[mlister.count].translucency_thickness.controller = bezier_float ()
				
					--MLister.vrayMatRC.addControl #spinner (("MatTransThSlide" + MLister.count as string) as name) "" \
					--	paramStr:(" range:[0,10000," + MLister.Matindex[MLister.count].translucency_thickness as string + \ 
					--	"] height:" + MLister.mly as string + " offset:[190," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"Translucency Thickness Amount\" controller:MLister.matIndex[" + MLister.count as string + \
					--	"].translucency_thickness.controller ")

					
					)

	
					------------------------------
					----- Bumpmap parameters------
					------------------------------
					
					if MLister.vraymaps == 5 do (
					-------------------------------------
					-- Bump Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_bump_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_bump_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatBumpSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_bump_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[-275," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"Bump Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_bump_multiplier.controller height:14")
					
					-------------------------------
					------- bumpmap toggle --------
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("bmpTogg" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_bump_on align:#left width:15 height:13 filter:on tooltip:\"Bumpmap Toggle\" ")
					
					MLister.vrayMatRC.addHandler (("bmpTogg" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_bump_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_bump_on = off")
	
					
					-----------------------------------------------------
					-- Edit bump map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("BumpMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Bump_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("BumpMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_bump)catch (messagebox@No bump-map defined@)")
	
					---------------------------------
					-- Bump Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatBumpMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_bump) as string) \
						paramStr:("tooltip:\"Select Bump Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatBumpMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_bump = texmap \n" + ("MatBumpMap" + MLister.count as string) + ".text = texmap as string")
						
					
				) -- end bump IF
				
					if MLister.vraymaps == 6 do (
					-------------------------------------
					-- Displace Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_displacement_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_displacement_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatDispSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_displacement_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[-275," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"Displace Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_displacement_multiplier.controller height:14")
						
					-------------------------------
					------- Displace toggle --------
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("dispTogg" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_displacement_on align:#left width:15 height:13 filter:on tooltip:\"Displacement Toggle\" ")
					
					MLister.vrayMatRC.addHandler (("dispTogg" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_displacement_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_displacement_on = off")
						
					-----------------------------------------------------
					-- Edit Displace map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("DispMatEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Displace_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("DispMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_displacement)catch (messagebox@No displacement-map defined@)")
	
					---------------------------------
					-- Displace Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatDispMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_displacement) as string) \
						paramStr:("tooltip:\"Select displacement Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatDispMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_displacement= texmap \n" + ("MatDispMap" + MLister.count as string) + ".text = texmap as string")
						
					

						
						
				) -- end displacement IF

				
				------------------------------
				----- Opacity parameters------
				------------------------------
					
				if MLister.vraymaps == 7 do (
					-------------------------------------
					-- Opacity Map Amount Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].texmap_opacity_multiplier.controller == undefined) do MLister.matIndex[mlister.count].texmap_opacity_multiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("MatOpSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].texmap_opacity_multiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[-275," + MLister.mlyo as string + "] width:45 scale:1 type:#integer tooltip:\"opacity Map Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].texmap_opacity_multiplier.controller height:14")
					
					-------------------------------
					------- Opacity toggle --------
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("opTogg" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_opacity_on align:#left width:15 height:13 filter:on tooltip:\"Opacity Toggle\" ")
					
					MLister.vrayMatRC.addHandler (("opTogg" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_opacity_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_opacity_on = off")
					
										
					-----------------------------------------------------
					-- Edit Opacity map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("OpMatEdit" + MLister.count as string) as name) ">" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Opacity_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("OpMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_opacity)catch (messagebox@No opacity-map defined@)")
	
					---------------------------------
					-- Opacity Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatOpMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_opacity) as string) \
						paramStr:("tooltip:\"Select Opacity Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatOpMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_opacity = texmap \n" + ("MatOpMap" + MLister.count as string) + ".text = texmap as string")
						
					
				) -- end opacity IF

			

				------------------------------
				----- Environment parameters------
				------------------------------
					
				if MLister.vraymaps == 8 do (
					-------------------------------
					------- Environment toggle --------
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("enTogg" + MLister.count as string) as name) "" paramStr:(" offset:[246," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].texmap_Environment_on align:#left width:15 height:13 filter:on tooltip:\"Environment Toggle\" ")
					
					MLister.vrayMatRC.addHandler (("enTogg" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].texmap_Environment_on = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].texmap_Environment_on = off")
					
					
	
					---------------------------------
					-- Environment Material ---
					---------------------------------
				
					MLister.vrayMatRC.addControl #mapbutton (("MatenvMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap_environment) as string) \
						paramStr:("tooltip:\"Select environment Map\" align:#left height:" + MLister.mly as string + " width:90 offset:[262," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MatenvMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap_environment = texmap \n" + ("MatenvMap" + MLister.count as string) + ".text = texmap as string")
											
					-----------------------------------------------------
					-- Edit Environment map material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("envMatEdit" + MLister.count as string) as name) ">" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Environment_map in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("envMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap_environment)catch (messagebox@No environment-map defined@)")
						
				) -- end Environment IF

	
	
	
					---------------------------------
					----- End controller defs -------
					---------------------------------
				) -- END OF VRAY MATERIAL CONTROLS
				
				----------------------------
				-- VRAYWRAPPER MATERIAL CONTROLS --
				----------------------------
				
				if (classof MLister.matIndex[MLister.count] == VRayMtlWrapper) Do 
				(
					----------------------------
					-- Select Material Toggle --
					----------------------------
				
----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("MatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(MLister.moredetail as string) + " offset:[-14,-3] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					MLister.vrayMatRC.addHandler (("MatSel" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.moredetail = state \n print MLister.moredetail \n MLister.refreshrollouts()")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10," + MLister.mlyo as string + "] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matindex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
			
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					

					
					--------------------------------------
					--------- Diffuse Parameters ---------
					--------------------------------------
					if MLister.vraymaps == 1 do (

										
										
					-----------------------------
					-- Base Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("vwrapperbase" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].basemtl) as string) \
						paramStr:("tooltip:\"Select Vray Light Map\" align:#left height:" + MLister.mly as string + " width:120 offset:[160," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("vwrapperbase" + MLister.count as string) as name) #'picked texmaps' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].basemtl = texmaps\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmaps as string ")
									
					--------------------------------------------------
					-- Edit diffuse map material in material editor --
					--------------------------------------------------
					MLister.vrayMatRC.addControl #Button (("vLightEdit" + MLister.count as string) as name) "e" \
						paramStr:(" offset:[280," + MLister.mlyo as string + "] align:#left" + " width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Vray Light Texmap in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("vLightEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("MLister.editmat MLister.matIndex[" + MLister.count as string + "].basemtl")


					---------------------------
					-- Generate GI --
					---------------------------
					--MLister.vrayMatRC.addControl #label (lbName()) "2-sided" paramStr:(" offset:[300," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					
					MLister.vrayMatRC.addControl #checkbox (("vwrapGiTog" + MLister.count as string) as name) "" paramStr:(" offset:[300," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].GenerateGI align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Generate GI\" ")
					
					MLister.vrayMatRC.addHandler (("vwrapGiTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].GenerateGI = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].GenerateGI = off")
	
					if (MLister.matIndex[mlister.count].GenerateGIMult.controller == undefined) do MLister.matIndex[mlister.count].GenerateGIMult.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("vwrapGiAmount" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1000," + MLister.Matindex[MLister.count].GenerateGIMult as string + \ 
						"] offset:[-157," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:0.1 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].GenerateGIMult.controller")

					MLister.vrayMatRC.addControl #checkbutton (("vwrapGicost" + MLister.count as string) as name) "C" paramStr:(" offset:[365," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].generateCaustics align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Generate GI\" ")
					
					MLister.vrayMatRC.addHandler (("vwrapGicost" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].generateCaustics = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].generateCaustics = off")
	
					---------------------------
					-- Receive GI --
					---------------------------
										
					MLister.vrayMatRC.addControl #checkbox (("vwrapRGiTog" + MLister.count as string) as name) "" paramStr:(" offset:[400," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].ReceiveGI align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Receive GI\" ")
					
					MLister.vrayMatRC.addHandler (("vwrapRGiTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].ReceiveGI = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].ReceiveGI = off")
	
					if (MLister.matIndex[mlister.count].ReceiveGIMult.controller == undefined) do MLister.matIndex[mlister.count].ReceiveGIMult.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("vwrapRGiAmount" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1000," + MLister.Matindex[MLister.count].ReceiveGIMult as string + \ 
						"] offset:[-57," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:0.1 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].ReceiveGIMult.controller")

					MLister.vrayMatRC.addControl #checkbutton (("vwrapRGicost" + MLister.count as string) as name) "C" paramStr:(" offset:[465," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].receiveCaustics align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Generate GI\" ")
					
					MLister.vrayMatRC.addHandler (("vwrapRGicost" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].receiveCaustics = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].receiveCaustics = off")
	
					if (MLister.matIndex[mlister.count].CausticsMult.controller == undefined) do MLister.matIndex[mlister.count].CausticsMult.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("vwrapCuasticMult" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1000," + MLister.Matindex[MLister.count].CausticsMult as string + \ 
						"] offset:[30," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:0.1 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].CausticsMult.controller")

					)
					
					if MLister.vraymaps == 2 do (

						MLister.vrayMatRC.addControl #checkbox (("vwrapmatteS" + MLister.count as string) as name) "" paramStr:(" offset:[195," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].MatteSurface align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Matte Surface\" ")
					
						MLister.vrayMatRC.addHandler (("vwrapmatteS" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].MatteSurface = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].MatteSurface = off")
	
						--MLister.vrayMatRC.addControl #label (lbName()) "Alpha.Contr." paramStr:(" offset:[185," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					

						if (MLister.matIndex[mlister.count].AlphaContribution.controller == undefined) do MLister.matIndex[mlister.count].AlphaContribution.controller = bezier_float ()
						
						MLister.vrayMatRC.addControl #spinner (("vwrapalphaA" + MLister.count as string) as name) "" \
							paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].AlphaContribution as string + \ 
							"] offset:[-227," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:0.01 type:#float controller:MLister.matIndex[" + MLister.count as string + \
							"].AlphaContribution.controller")

						MLister.vrayMatRC.addControl #checkbutton (("vwrapshadows" + MLister.count as string) as name) "Sh" paramStr:(" offset:[300," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].Matte_Shadows align:#left width:25 height:" + MLister.mly as string + " filter:on tooltip:\"Matte Shadows\" ")
					
						MLister.vrayMatRC.addHandler (("vwrapshadows" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].Matte_Shadows = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].Matte_Shadows = off")
	
						MLister.vrayMatRC.addControl #checkbutton (("vwrapaffectA" + MLister.count as string) as name) "A.A." paramStr:(" offset:[330," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].Matte_ShadowsAffectAlpha align:#left width:25 height:" + MLister.mly as string + " filter:on tooltip:\"Matte Shadows\" ")
					
						MLister.vrayMatRC.addHandler (("vwrapaffectA" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].Matte_ShadowsAffectAlpha = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].Matte_ShadowsAffectAlpha = off")
	
					-----------------------------
					----- matte Colour ------
					------------------------------

					MLister.vrayMatRC.addControl #colorPicker (("MattranCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[355," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #Matte_ShadowColor) as string + \
						" width:35 align: #left height:" + MLister.mly as string + " fieldWidth:15")
					MLister.vrayMatRC.addHandler (("MattranCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #Matte_ShadowColor val")

					-------------------------------------
					-- Brightness Spinner ----
					-------------------------------------
					
					if (MLister.matIndex[mlister.count].Matte_ShadowBrightness.controller == undefined) do MLister.matIndex[mlister.count].Matte_ShadowBrightness.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("vwrapShBr" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].Matte_ShadowBrightness as string + \ 
						"] height:" + MLister.mly as string + " offset:[-60," + MLister.mlyo as string + "] width:45 scale:.01 type:#float  controller:MLister.matIndex[" + MLister.count as string + \
						"].Matte_ShadowBrightness.controller height:14")

					if (MLister.matIndex[mlister.count].Matte_ReflectionMultiplier.controller == undefined) do MLister.matIndex[mlister.count].Matte_ReflectionMultiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("vwrapRefMult" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].Matte_ReflectionMultiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[10," + MLister.mlyo as string + "] width:45 scale:.01 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].Matte_ReflectionMultiplier.controller height:14")

					if (MLister.matIndex[mlister.count].Matte_RefractionMultiplier.controller == undefined) do MLister.matIndex[mlister.count].Matte_RefractionMultiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("vwrapRefrMult" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].Matte_RefractionMultiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[80," + MLister.mlyo as string + "] width:45 scale:.01 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].Matte_RefractionMultiplier.controller height:14")
					
					if (MLister.matIndex[mlister.count].Matte_GIMultiplier.controller == undefined) do MLister.matIndex[mlister.count].Matte_GIMultiplier.controller = bezier_float ()
				
					MLister.vrayMatRC.addControl #spinner (("vwrapGIMult" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].Matte_GIMultiplier as string + \ 
						"] height:" + MLister.mly as string + " offset:[150," + MLister.mlyo as string + "] width:45 scale:.01 type:#float controller:MLister.matIndex[" + MLister.count as string + \
						"].Matte_GIMultiplier.controller height:14")




					)
















				) -- END OF VRAYWRAPPER MATERIAL CONTROLS

				----------------------------
				-- VRAYLIGHT MATERIAL CONTROLS --
				----------------------------
				
				if (classof MLister.matIndex[MLister.count] == VRayLightMtl) Do 
				(

					----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("MatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(MLister.moredetail as string) + " offset:[-14,-3] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					MLister.vrayMatRC.addHandler (("MatSel" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.moredetail = state \n print MLister.moredetail \n MLister.refreshrollouts()")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10," + MLister.mlyo as string + "] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matindex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
			
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					

					
					--------------------------------------
					--------- Diffuse Parameters ---------
					--------------------------------------

					---------------------------
					-- Diffuse Colour Picker --
					---------------------------
					
					MLister.vrayMatRC.addControl #colorPicker (("MatLCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[160," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #color) as string + \
						" width:35 height:" + MLister.mly as string + " fieldWidth:16")
					MLister.vrayMatRC.addHandler (("MatLCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #color  val")
					
					---------------------------------
					-- Light Multiplier Spinner ---
					---------------------------------
					--MLister.vrayMatRC.addControl #label (lbName()) "Multiplier:" paramStr:(" offset:[200," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					
					if (MLister.matIndex[mlister.count].multiplier.controller == undefined) do MLister.matIndex[mlister.count].multiplier.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("vlightmult" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,1000," + MLister.Matindex[MLister.count].multiplier as string + \ 
						"] offset:[-227," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:1 type:#integer controller:MLister.matIndex[" + MLister.count as string + \
						"].multiplier.controller")
					
					---------------------------
					-- 2sided Map Toggle --
					---------------------------
					--MLister.vrayMatRC.addControl #label (lbName()) "2-sided" paramStr:(" offset:[300," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					
					MLister.vrayMatRC.addControl #checkbox (("vlighttwo" + MLister.count as string) as name) "" paramStr:(" offset:[340," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].twoSided align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Use 2-sided\" ")
					
					MLister.vrayMatRC.addHandler (("vlighttwo" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].twoSided = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].twoSided = off")
	
					-----------------------------
					-- Diffuse Colour Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("vLightTex" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].texmap) as string) \
						paramStr:("tooltip:\"Select Vray Light Map\" align:#left height:" + MLister.mly as string + " width:150 offset:[420," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("vLightTex" + MLister.count as string) as name) #'picked texmaps' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].texmap = texmaps\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmaps as string ")
									
					--------------------------------------------------
					-- Edit diffuse map material in material editor --
					--------------------------------------------------
					MLister.vrayMatRC.addControl #Button (("vLightEdit" + MLister.count as string) as name) "<< Edit" \
						paramStr:(" offset:[570," + MLister.mlyo as string + "] align:#left" + " width:40 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Vray Light Texmap in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("vLightEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("MLister.editmat MLister.matIndex[" + MLister.count as string + "].texmap")

					

























	) -- END OF VRAYLIGHT MATERIAL CONTROLS

					
				
				------------------------------------------	
				----- Multi Material Controllers ---------
				------------------------------------------
					
				if (classof MLister.matIndex[Mlister.count] ==  multimaterial) Do 
				(
					print MLister.matIndex[MLister.count]
					------------------------------
					-- Material Name Text field --
					------------------------------
						
					MLister.vrayMatRC.addControl #editText (("MMatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10,0] align:#left width:60 height:16 ")
					MLister.vrayMatRC.addHandler (("MMatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
						
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(	
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[52,-18] align:#left " + \
							" width:10 height:13 filter:on tooltip:\"select objects with this material\" ")
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' \
							codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
				
					MLister.vrayMatRC.addControl #Button (("MMatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[62,-18] align:#left" + " width:10 height:13 filter:on tooltip:\"Apply material to selected objects\" ") 
					
					MLister.vrayMatRC.addHandler (("MMatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do ($.material = MLister.matIndex[" + MLister.count as string + "]))catch(messagebox @Material not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MMatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[72,-18] align:#left" + " width:10 height:13 filter:on tooltip:\"Edit material in material editor\" ") 
						
					MLister.vrayMatRC.addHandler (("MMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[82,-18] align:#left width:10 height:13 filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("MViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("try(curmatoff MLister.matIndex[" + MLister.count as string + "])catch()")
					
					--------------------------------------
					--------- Material Buttons -----------
					--------------------------------------

					for i = 1 to MLister.matIndex[Mlister.count].materiallist.count do 
					(	
						if classof MLister.matIndex[Mlister.count].materiallist != multimaterial do
						(
							MLister.vrayMatRC.addControl #mapbutton (("MultiMatMap" + i as string + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].materiallist[i].name) as string) \
								paramStr:("tooltip:\"Select Map\" align:#left height:15 width:60 offset:[" + ((i*63)+34) as string + ",-20]")
							MLister.vrayMatRC.addHandler (("MultiMatMap" + i as string + MLister.count as string) as name) #'picked texmap' filter:on \
								codeStr:("MLister.MatIndex[" + MLister.count as string + "].materiallist[" + i as string + "] = texmap\n" + ("MultiMatMap" + i as string + MLister.count as string) + ".text = classof texmap as string ")
						)
					)		
					
					
				) -- END OF MULTIMATERIAL CONTROLS
				
				
				
				if (classof MLister.matIndex[MLister.count] == compositematerial) Do 
				(
					---------------------------------
					-- COMPOSITE MATERIAL CONTROLS --
					---------------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("CMatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(isMatSelected as string) + " offset:[-14,0] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10,-24] align:#left width:60 height:16 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matIndex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[52,-19] align:#left " + \
							" width:10 height:13 filter:on tooltip:\"select objects with this material\" ")
							
							
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[60,-18] align:#left width:10 height:13 filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matIndex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[70,-18] align:#left width:10 height:13 filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[80,-18] align:#left width:10 height:13 filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					---------------------------------
					----- End controller defs -------
					---------------------------------
				) -- END OF COMPOSITE MATERIAL CONTROLS

				----------------------------
				-- BLEND MATERIAL CONTROLS --
				----------------------------
				
				if (classof MLister.matIndex[MLister.count] == blend) Do 
				(
					----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("blMatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(isMatSelected as string) + " offset:[-14,0] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("blMatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10,-24] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("blMatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.vraymatlist[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("blObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
							
							
						MLister.vrayMatRC.addHandler (("blObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("blMatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("blMatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("blMatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("blMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("blViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("blViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					
					
					--------------------------------------
					-------- Material 1 Parameters -------
					--------------------------------------
					---------------------------
					-- Map1 Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("bmat1tog" + MLister.count as string) as name) "" paramStr:(" offset:[260," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].map1enabled align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Use Map1\" ")
					
					MLister.vrayMatRC.addHandler (("bmat1tog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].map1enabled = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].map1enabled = off")
	
					-----------------------------
					--  Matp1 Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("bmat1" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].map1) as string) \
						paramStr:("tooltip:\"Select map1 Material\" align:#left height:" + MLister.mly as string + " width:100 offset:[160," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("bmat1" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].map1 = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
	
					--------------------------------------
					-------- Material 2 Parameters -------
					--------------------------------------
					---------------------------
					-- Map2 Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("bmat2tog" + MLister.count as string) as name) "" paramStr:(" offset:[375," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].map1enabled align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Use Map1\" ")
					
					MLister.vrayMatRC.addHandler (("bmat2tog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].map1enabled = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].map1enabled = off")
	
					-----------------------------
					--  Matp2 Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("bmat2" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].map1) as string) \
						paramStr:("tooltip:\"Select map1 Material\" align:#left height:" + MLister.mly as string + " width:100 offset:[275," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("bmat2" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].map1 = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
	
					--------------------------------------
					-------- Material mask Parameters -------
					--------------------------------------
					---------------------------
					-- Map mask Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("bmatmtog" + MLister.count as string) as name) "" paramStr:(" offset:[490," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].maskenabled align:#left width:15 height:" + MLister.mly as string + " filter:on tooltip:\"Use Map1\" ")
					
					MLister.vrayMatRC.addHandler (("bmatmtog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].maskenabled = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].maskenabled = off")
	
					-----------------------------
					--  Map mask Material --
					-----------------------------
					
					MLister.vrayMatRC.addControl #mapbutton (("bmatm" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].mask) as string) \
						paramStr:("tooltip:\"Select map1 Material\" align:#left height:" + MLister.mly as string + " width:100 offset:[390," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("bmatm" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].mask = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
					
					---------------------------------
					-- AMount Spinner ---
					---------------------------------
					if (MLister.matIndex[mlister.count].mixamount.controller == undefined) do MLister.matIndex[mlister.count].mixamount.controller = bezier_float ()
					
					MLister.vrayMatRC.addControl #spinner (("MatDiffSlide" + MLister.count as string) as name) "" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].mixamount as string + \ 
						"] offset:[35," + MLister.mlyo as string + "] width:45 height:" + MLister.mly as string + " scale:1 type:#integer tooltip:\"Mix Amount\" controller:MLister.matIndex[" + MLister.count as string + \
						"].mixamount.controller")
					
					-----------------------------
					--  Interactive  --
					-----------------------------
				
					MLister.vrayMatRC.addControl #radiobuttons (("blendIn" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"M1\", \"M2\", \"Msk\") default:(MLister.MatIndex[" + MLister.count as string + "].interactive+1) offset:[560," + MLister.mlyo as string + "] align:#left width:100 height:" + MLister.mly as string + "")
					MLister.vrayMatRC.addHandler (("blendIn" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].interactive = (blendIn" + MLister.count as string + ".state)-1 \n print MLister.MatIndex[" + MLister.count as string + "].interactive")
								
				) -- END OF BLEND MATERIAL CONTROLS
				
				-------------------------------
				-- SHELLAC MATERIAL CONTROLS --
				-------------------------------
				
				if (classof MLister.matIndex[MLister.count] == shellac) Do 
				(
					

----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("MatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(MLister.moredetail as string) + " offset:[-14,-3] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					MLister.vrayMatRC.addHandler (("MatSel" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.moredetail = state \n print MLister.moredetail \n MLister.refreshrollouts()")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10," + MLister.mlyo as string + "] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matindex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
			
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					
					
					-----------------------------
					-- Base Material --
					-----------------------------
					MLister.vrayMatRC.addControl #label (lbName()) "Base:" paramStr:(" offset:[165," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")

					MLister.vrayMatRC.addControl #mapbutton (("shellbaseMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].shellacmtl1) as string) \
						paramStr:("tooltip:\"Select Diffuse Map\" align:#left height:" + MLister.mly as string + " width:120 offset:[195," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("shellbaseMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].shellacmtl1 = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
					
					-----------------------------------------------------
					-- Edit Base Material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("shbMatEdit" + MLister.count as string) as name) "Edit" \
						paramStr:(" offset:[320," + MLister.mlyo as string + "] align:#left" + " width:30 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Base material in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("shbMatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].shellacmtl1)catch (messagebox@No refraction glossiness defined@)")
	

					-----------------------------
					-- Shellac Material --
					-----------------------------
					MLister.vrayMatRC.addControl #label (lbName()) "Shellac:" paramStr:(" offset:[360," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")

					MLister.vrayMatRC.addControl #mapbutton (("shallshell" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].shellacmtl2) as string) \
						paramStr:("tooltip:\"Select Diffuse Map\" align:#left height:" + MLister.mly as string + " width:120 offset:[400," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("shallshell" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].shellacmtl2 = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
					-----------------------------------------------------
					-- Edit Shellac Material in material editor --
					-----------------------------------------------------
				
					MLister.vrayMatRC.addControl #Button (("shEdit" + MLister.count as string) as name) "Edit" \
						paramStr:(" offset:[525," + MLister.mlyo as string + "] align:#left" + " width:30 height:" + MLister.mly as string + " filter:on tooltip:\"Edit Shellac material in material editor\" ") 
				
					MLister.vrayMatRC.addHandler (("shEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(MLister.editmat MLister.matIndex[" + MLister.count as string + "].shellacmtl2)catch (messagebox@No refraction glossiness defined@)")
	

					---------------------------------
					--Shellac Color Blend Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].shellacColorBlend.controller == undefined) do MLister.matIndex[mlister.count].shellacColorBlend.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("shelblend" + MLister.count as string) as name) "Colour Blend:" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].shellacColorBlend as string + \ 
						"] offset:[10," + MLister.mlyo as string + "] fieldwidth:35 scale:1 type:#float tooltip:\"shellacColorBlend\" controller:MLister.matIndex[" + MLister.count as string + \
						"].shellacColorBlend.controller height:" + MLister.mly as string + "")
					



				) -- END OF SHELLAC MATERIAL CONTROLS
				
				
				-------------------------------
				-- MATT MATERIAL CONTROLS --
				-------------------------------
				
				if (classof MLister.matIndex[MLister.count] == MatteShadow) Do 
				(
			
		
					----------------------------
					-- Select Material Toggle --
					----------------------------
				
					MLister.vrayMatRC.addControl #checkButton (("MatSel" + MLister.count as string) as name) "" \
						paramStr:("checked:" +(MLister.moredetail as string) + " offset:[-14,-3] align:#left" + \
						" width:7 height:18 tooltip:\"select material\"")
					MLister.vrayMatRC.addHandler (("MatSel" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.moredetail = state \n print MLister.moredetail \n MLister.refreshrollouts()")
					
					------------------------------
					-- Material Name Text field --
					------------------------------
					
					MLister.vrayMatRC.addControl #editText (("MatName" + MLister.count as string) as name) "" \
						paramStr:(" text:\"" + MLister.matindex[MLister.count].name + "\" offset:[-10," + MLister.mlyo as string + "] align:#left width:120 height:15 ")
					MLister.vrayMatRC.addHandler (("MatName" + MLister.count as string) as name) #'changed txt' filter:on \
						codeStr:("MLister.matindex[" + MLister.count as string + "].name = txt")
					
					----------------------------
					-- Select Objects Button ---
					----------------------------
					
					if ((isMaterialInUse MLister.MatIndex[MLister.count]) != undefined) do
					(
						MLister.vrayMatRC.addControl #Button (("ObjSel" + MLister.count as string) as name) "S" \
							paramStr:(" offset:[112," + MLister.mlyo as string + "] align:#left " + \
							" width:10 height:" + MLister.mly as string + " filter:on tooltip:\"select objects with this material\" ")
			
						MLister.vrayMatRC.addHandler (("ObjSel" + MLister.count as string) as name) #'pressed' codeStr:("MLister.selectObjs MLister.MatIndex[" + MLister.count as string + "]")
					)	
						
					-----------------------------
					-- Apply to Objects Button --
					-----------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatApply" + MLister.count as string) as name) "A" \
						paramStr:(" offset:[124," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Apply material to selected objects\" ") 
							
					MLister.vrayMatRC.addHandler (("MatApply" + MLister.count as string) as name) #'pressed' \
						codeStr:("try (if $.material != undefined do $.material = (MLister.matindex[" + MLister.count as string + "]))catch(messagebox @Object not selected@)")
			
					--------------------------------------
					-- Edit material in material editor --
					--------------------------------------
						
					MLister.vrayMatRC.addControl #Button (("MatEdit" + MLister.count as string) as name) "E" \
						paramStr:(" offset:[136," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Edit material in material editor\" ") 
					
					MLister.vrayMatRC.addHandler (("MatEdit" + MLister.count as string) as name) #'pressed' \
						codeStr:("try(if (MLister.matindex[" + MLister.count as string + "] != undefined) do (if (mateditor.isopen() == false) do (mateditor.open ())\n local activeslot = medit.getActiveMtlSlot()\n setMeditMaterial activeSlot MLister.matindex[" + MLister.count as string + "]))catch (messagebox @There was a problem putting the material to the editor@)") 			
			
					--------------------------------------
					-- Switch off materials in viewport --
					--------------------------------------
					
					MLister.vrayMatRC.addControl #Button (("ViewMatOff" + MLister.count as string) as name) "O" \
						paramStr:(" offset:[148," + MLister.mlyo as string + "] align:#left width:10 height:" + MLister.mly as string + " filter:on tooltip:\"Switch off materials in viewport\" ") 
						
					MLister.vrayMatRC.addHandler (("ViewMatOff" + MLister.count as string) as name) #'pressed' codeStr:("MLister.curmatoff MLister.matindex[" + MLister.count as string + "]")
					
					if MLister.vraymaps == 1 do (

					-------------------------------
					-- opaque alpha ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("opalph" + MLister.count as string) as name) "" paramStr:(" offset:[165," + (MLister.mlyo) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].opaqueAlpha align:#left width:14 height:" + MLister.mly as string + " filter:on tooltip:\"Opaque Alpha\" ")
					
					MLister.vrayMatRC.addHandler (("opalph" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].opaqueAlpha = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].opaqueAlpha = false")
					MLister.vrayMatRC.addControl #label (lbName()) "Opaque Alpha" paramStr:(" offset:[180," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					)
					if MLister.vraymaps == 2 do (

					-------------------------------
					-- Apply Atmosphere ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("appat" + MLister.count as string) as name) "Apply. Atm." paramStr:(" offset:[165," + (MLister.mlyo) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].applyAtmosphere align:#left width:14 height:" + MLister.mly as string + " filter:on tooltip:\"Apply Atmosphere\" ")
					
					MLister.vrayMatRC.addHandler (("appat" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].applyAtmosphere = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].applyAtmosphere  = false")
					MLister.vrayMatRC.addControl #label (lbName()) "Apply Atmosphere" paramStr:(" offset:[180," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")
					-----------------------------
					--  Atmosphere RadioBtns  --
					-----------------------------
				
					MLister.vrayMatRC.addControl #radiobuttons (("at" + MLister.count as string) as name) ""  paramStr:(" labels:#(\"@Background Depth\", \"@Object Depth\") default:(MLister.MatIndex[" + MLister.count as string + "].atmosphereDepth+1) offset:[270," + MLister.mlyo as string + "] align:#left width:50 height:" + MLister.mly as string + "")
					MLister.vrayMatRC.addHandler (("at" + MLister.count as string) as name) #'changed state' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].atmosphereDepth = (at" + MLister.count as string + ".state - 1) \n print MLister.MatIndex[" + MLister.count as string + "].atmosphereDepth")
					)
					
					if MLister.vraymaps == 3 do (

					-------------------------------
					-- recieve shadows ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("rshad" + MLister.count as string) as name) "I" paramStr:(" offset:[165," + (MLister.mlyo + 1) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].receiveshadows align:#left width:14 height:" + MLister.mly as string + " filter:on tooltip:\"Receive Shadows\" ")
					
					MLister.vrayMatRC.addHandler (("rshad" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].receiveshadows  = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].receiveshadows  = false")
					MLister.vrayMatRC.addControl #label (lbName()) "Receive Shadow" paramStr:(" offset:[180," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")

					-------------------------------
					-- Affect Alpha ---
					-------------------------------
				
					MLister.vrayMatRC.addControl #checkbox (("affa" + MLister.count as string) as name) "I" paramStr:(" offset:[280," + (MLister.mlyo + 1) as string + "] checked:MLister.matIndex[" + MLister.count as string + "].affectAlpha  align:#left width:14 height:" + MLister.mly as string + " filter:on tooltip:\"Affect Alpha\" ")
					
					MLister.vrayMatRC.addHandler (("affa" + MLister.count as string) as name) #'changed state' codeStr:("if state == true do MLister.matIndex[" + MLister.count as string + "].affectAlpha  = true \n if state == false do MLister.matIndex[" + MLister.count as string + "].affectAlpha = false")
					MLister.vrayMatRC.addControl #label (lbName()) "Affect Alpha" paramStr:(" offset:[295," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")

					---------------------------------
					--shadow brightness Spinner--
					---------------------------------
				
					if (MLister.matIndex[mlister.count].shadowBrightness.controller == undefined) do MLister.matIndex[mlister.count].shadowBrightness.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("shadb" + MLister.count as string) as name) "Shadow Brightness:" \
						paramStr:(" range:[0,1," + MLister.Matindex[MLister.count].shadowBrightness as string + \ 
						"] offset:[-150," + MLister.mlyo as string + "] fieldwidth:35 scale:.01 type:#float tooltip:\"Shadow Brightness\" controller:MLister.matIndex[" + MLister.count as string + \
						"].shadowBrightness.controller height:" + MLister.mly as string + "")
						
					
					
					-----------------------------
					-- Shadow Colour Material --
					-----------------------------
					MLister.vrayMatRC.addControl #label (lbName()) "Colour:" paramStr:(" offset:[525," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")


					MLister.vrayMatRC.addControl #colorPicker (("shadCol" + MLister.count as string) as name) "" \
						paramStr:(" offset:[560," + MLister.mlyo as string + "] color:" + (MLister.getMatProp MLister.MatIndex[MLister.count] #color ) as string + \
						" width:35 height:" + MLister.mly as string + " fieldWidth:16")
					MLister.vrayMatRC.addHandler (("shadCol" + MLister.count as string) as name) #'changed val' filter:on \
						codeStr:("MLister.setMatProp MLister.MatIndex[" + MLister.count as string + "] #color val")
					)
								
					
					if MLister.vraymaps == 4 do (

					---------------------------------
					--refraction amount Spinner--
					---------------------------------
					--MLister.vrayMatRC.addControl #label (lbName()) "Amount:" paramStr:(" offset:[165," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")


					if (MLister.matIndex[mlister.count].amount.controller == undefined) do MLister.matIndex[mlister.count].amount.controller = bezier_float ()
					MLister.vrayMatRC.addControl #spinner (("refa" + MLister.count as string) as name) "Amount:" \
						paramStr:(" range:[0,100," + MLister.Matindex[MLister.count].amount as string + \ 
						"] offset:[-400," + MLister.mlyo as string + "] fieldwidth:45 scale:1 type:#float tooltip:\"reflection\" controller:MLister.matIndex[" + MLister.count as string + \
						"].amount.controller height:" + MLister.mly as string + "")
						
					
					-------------------------------
					-- Additive Reflection ---
					-------------------------------
					MLister.vrayMatRC.addControl #label (lbName()) "Additive Reflection" paramStr:(" offset:[300," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")


					MLister.vrayMatRC.addControl #checkbox (("refadd" + MLister.count as string) as name) "Additive Reflection" paramStr:(" offset:[285," + (MLister.mlyo) as string + "] tristate:(MLister.matIndex[" + MLister.count as string + "].additiveReflection) align:#left width:14 height:14 filter:on tooltip:\"Additive Reflection\" ")
					
					MLister.vrayMatRC.addHandler (("refadd" + MLister.count as string) as name) #'changed state' codeStr:("if state == 1 do MLister.matIndex[" + MLister.count as string + "].additiveReflection = 1 /n if state == 0 do MLister.matIndex[" + MLister.count as string + "].additiveReflection = 0")
	

					-----------------------------
					-- Matt Material --
					-----------------------------
					MLister.vrayMatRC.addControl #label (lbName()) "Map:" paramStr:(" offset:[420," + (MLister.mlyo) as string + "] align:#LEFT height:" + MLister.mly as string + "")

					MLister.vrayMatRC.addControl #mapbutton (("MattMap" + MLister.count as string) as name) ((MLister.MatIndex[MLister.count].map) as string) \
						paramStr:("tooltip:\"Select Diffuse Map\" align:#left height:" + MLister.mly as string + " width:120 offset:[450," + MLister.mlyo as string + "]")
					MLister.vrayMatRC.addHandler (("MattMap" + MLister.count as string) as name) #'picked texmap' filter:on \
						codeStr:("MLister.MatIndex[" + MLister.count as string + "].map = texmap\n" + ("MatDiffMap" + MLister.count as string) + ".text = classof texmap as string ")
					
					---------------------------
					-- Matt Material Toggle --
					---------------------------
					
					MLister.vrayMatRC.addControl #checkbox (("mattTog" + MLister.count as string) as name) "" paramStr:(" offset:[575," + MLister.mlyo as string + "] checked:MLister.matIndex[" + MLister.count as string + "].useReflMap align:#left width:15 height:13 filter:on tooltip:\"Use Reflection Map\" ")
					
					MLister.vrayMatRC.addHandler (("mattTog" + MLister.count as string) as name) #'changed state' codeStr:("if state == on do MLister.matIndex[" + MLister.count as string + "].useReflMap  = on \n if state == off do MLister.matIndex[" + MLister.count as string + "].useReflMap  = off")
					
					)

					
					
					---------------------------------
					----- End controller defs -------
					---------------------------------
				) -- END OF MATT MATERIAL CONTROLS		
				

				
			) -- END OF SIMPLE MODE
								
						
			append MLister.UIControlList[2][MLister.Count] (("MatSel" + MLister.count as string) as name)
			MLister.UIControlList[1][MLister.count] = MLister.MatIndex[MLister.count][1]
		
		) -- END FN CREATECONTROLS
			
			
		-- BUILD ROLLOUT CONTENTS
		
		
		-- STANDARD MATERIALS --
			
		if (Mlister.standardMatList.count > 0) do
		(
			MLister.vrayMatRC.addControl #label #Standarditle "Standard" paramStr:" align:#left"
			--MLister.vrayMatRC.addControl #groupbox (("standardgroup" + MLister.count as string) as name) "Standard Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			writetitle mat:"standard"
			for x in 1 to Mlister.standardMatList.count do
			(
				append MLister.MatIndex Mlister.standardMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END STANDARD MATERIALS -- 
		
		-- VRAY MATERIALS --
			
		if (Mlister.vrayMatList.count > 0) do
		(
			MLister.vrayMatRC.addControl #label #vrayTitle "VRay" paramStr:"  align:#left offset:[0,10]"
			writetitle mat:"vray"
				
			for x in 1 to Mlister.vrayMatList.count do
			(
				append MLister.MatIndex Mlister.vrayMatList[x]
				createControls ()
					
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
			
		)
			
		-- END VRAY MATERIALS -- 
			
		-- VRAYWRAPPER MATERIALS --
			
		if (Mlister.vraywrapperMatList.count > 0) do
		(
			MLister.vrayMatRC.addControl #label #vraywrapperTitle "VRay Wrapper" paramStr:" align:#left"
			writetitle mat:"vraywrapper"
				
			for x in 1 to Mlister.vraywrapperMatList.count do
			(
				append MLister.MatIndex Mlister.vraywrapperMatList[x]
				createControls ()
					
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
			
		)
			
		-- END VRAYWRAPPER MATERIALS -- 
		
		-- VRAYLIGHT MATERIALS --
			
		if (Mlister.vraylightMatList.count > 0) do
		(
			MLister.vrayMatRC.addControl #label #vraylightTitle "VRay Light" paramStr:" align:#left"
			writetitle mat:"vraylight"
				
			for x in 1 to Mlister.vraylightMatList.count do
			(
				append MLister.MatIndex Mlister.vraylightMatList[x]
				createControls ()
					
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
			
		)
			
		-- END VRAYLIGHT MATERIALS -- 
			
				
			
		-- MULTI MATERIALS --
			
		if (Mlister.multiMatList.count > 0)do
		(
			--MLister.vrayMatRC.addControl #groupbox (("multigroup" + MLister.count as string) as name) "MultiSubObject Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			MLister.vrayMatRC.addControl #label #multititle "Multi/sub" paramStr:" align:#left"	
	
			writetitle mat:"multi"
				
			for x in 1 to Mlister.multiMatList.count do
			(
				append MLister.MatIndex Mlister.multiMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END multi MATERIALS -- 
		
		-- COMPOSITE MATERIALS --
			
		if (Mlister.multiMatList.count > 0)do
		(
			-- MLister.vrayMatRC.addControl #groupbox (("multigroup" + MLister.count as string) as name) "MultiSubObject Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			MLister.vrayMatRC.addControl #label #comptitle "Composite" paramStr:" align:#left"	
	
			writetitle mat:"composite"
				
			for x in 1 to Mlister.compositeMatList.count do
			(
				append MLister.MatIndex Mlister.compositeMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END COMPOSITE MATERIALS -- 
		
		-- BLEND MATERIALS --
			
		if (Mlister.blendMatList.count > 0)do
		(
			-- MLister.vrayMatRC.addControl #groupbox (("multigroup" + MLister.count as string) as name) "MultiSubObject Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			MLister.vrayMatRC.addControl #label #blendtitle "Blend Materials" paramStr:" align:#left"	
	
			writetitle mat:"blend"
				
			for x in 1 to Mlister.blendMatList.count do
			(
				append MLister.MatIndex Mlister.blendMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END BLEND MATERIALS -- 

		-- SHELLAC MATERIALS --
			
		if (Mlister.shellacMatList.count > 0)do
		(
			-- MLister.vrayMatRC.addControl #groupbox (("multigroup" + MLister.count as string) as name) "MultiSubObject Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			MLister.vrayMatRC.addControl #label #shellactitle "Shellac Materials" paramStr:" align:#left"	
	
			writetitle mat:"shellac"
				
			for x in 1 to Mlister.shellacMatList.count do
			(
				append MLister.MatIndex Mlister.shellacMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END SHELLAC MATERIALS -- 
		
		-- MATT MATERIALS --
			
		if (Mlister.mattMatList.count > 0)do
		(
			-- MLister.vrayMatRC.addControl #groupbox (("multigroup" + MLister.count as string) as name) "MultiSubObject Materials" paramStr:(" offset:[-10,-5] width:480 height:" + (26+(MLister.vraymatlist.count * (MLister.vraymatspace/2))) as string + " ") 	
			MLister.vrayMatRC.addControl #label #matttitle "Matt/Shadow" paramStr:" align:#left"	
	
			writetitle mat:"matt"
				
			for x in 1 to Mlister.mattMatList.count do
			(
				append MLister.MatIndex Mlister.mattMatList[x]
				createControls ()
				MLister.count += 1
				MLister.MatInspectorSetup.pbar.value = MLister.count*100/MLister.totalMatCount
			)
		)
			
		-- END MATT MATERIALS -- 

		
		
		
		
		----------- end fn create controls --------------
			
		local CanAddControls = true
		local MatCountLimit = 150
			
		-- Callback handlers
		MLister.vrayMatRC.addHandler "vraymatsrollout" #'open' filter:off codeStr:("MLister.DeleteCallback = when MLister.UIControlList[1] deleted obj do" + \
		"\n(\nlocal foundme = findItem MLister.UIControllist[1] obj\n" + \
		"if foundMe > 0 do\n(\n" + \
		"MLister.disableUIElements MLister.UIControlList[2][foundMe]\n)\n)")
		MLister.vrayMatRC.addHandler "vrayMatsRollout" #'close' filter:off \	
			codeStr:"DeleteChangeHandler MLister.DeleteCallback"		
			
		MLister.MatInspectorSetup.pbar.value = 0
		MLister.MatInspectorSetup.pbar.visible = false 
		MLister.vrayMatRC.end()
	)-- end function CreateMatRollout
	
	MLister.CreateMatRollout = CreateMatRollout
		
	parseScene sceneMaterials
	
	local matFilterTypes
	local standardItems = #()
	try(
		if MLister.standardMatlist.count > 0 do standardItems = getpropnames MLister.standardmatlist[1])catch() 
	local vrayItems = #()
	try(
		if MLister.vraymatlist.count > 0 do vrayItems = getpropnames MLister.vraymatlist[1])catch()
	local vraywrapItems = #() 
	try(
		if MLister.vraywrappermatlist.count > 0 do vraywrapItems = getpropnames MLister.vraywrappermatlist[1])catch()
	local vraylightItems = #() 
	try(
		if MLister.vraylightmatlist.count > 0 do vraylightItems = getpropnames MLister.vraylightmatlist[1])catch()
	local multiItems = #() 
	try(
		if MLister.multimatlist.count > 0 do multiItems = getpropnames MLister.multimatlist[1])catch()
	local compositeItems = #() 
	try(
		if MLister.compositematlist.count > 0 do compositeItems = getpropnames MLister.compositematlist[1])catch()
	local blendItems = #() 
	try(
		if MLister.blendmatlist.count > 0 do blendItems = getpropnames MLister.blendmatlist[1])catch()
	local shellacItems = #() 
	try(
		if MLister.shellacmatlist.count > 0 do shellacItems = getpropnames MLister.shellacmatlist[1])catch()
	local mattItems  = #()
	try(
		if MLister.mattmatlist.count > 0 do mattItems = getpropnames MLister.mattmatlist[1]) catch()
				
	MLister.MatModeSetup = 
	(
		local MatModeSetup
			
		rollout MatModeSetup "About" 
		(
			--------------------------------------------------
			-- bitmap image to be added. Version info, etc. --
			--------------------------------------------------
		)
	)
		
		
		------- MAT INSPECTOR SETUP ------------
	MLister.MatInspectorSetup = 
	(
		local MatInspectorSetup
		rollout MatInspectorSetup "Material Filter" -- Localize
		(	
			radiobuttons matFilter labels:#("Blend", "Composite", "Matt/Sh", "Multi/sub", "Shellac", "Standard", "VrayLight", "VrayMat", "VrayWrapper") default:8
			button btnRefresh "Refresh" offset:[1,0] height:14 align:#right
			progressbar pbar width:120 pos:(btnRefresh.pos - [125,-1])
			
			on matFilter changed state do 
			(
				MLister.matFilter = state
				parseScene scenematerials
				refreshRollouts()
			)
			
			
				
			on btnRefresh pressed do
			(
				parseScene scenematerials
				refreshrollouts()		
			)
						
			on matInspectorSetup close do
			(
				callbacks.removeScripts id:#MListerRollout
				dialogUp = false
				-- updateToolbarButtons()
			)
			
			on MatInspectorSetup open do
			(
				pbar.visible = false
				/* try (removerollout MLister.MatInspectorListRollout MLister.MatInspectorFloater) catch()
				MLister.MatInspectorListRollout = MLister.CreateMatRollout (sceneMaterials)
				
				if MLister.MatInspectorListRollout != undefined do
				addRollout MLister.MatInspectorListRollout MLister.MatInspectorFloater -- Add the material list rollout
				
				MLister.vrayMatRC = undefined
				*/ 
				--parseScene sceneMaterials

				--refreshrollouts()
				
				--MLister.vrayMatRC = undefined
				--Callbacks to remove Floater
				--callBacks.AddScript #systemPreReset "CloseRolloutFloater MLister.MatInspectorFloater" id:#MListerRollout  -- do not localize
				--callBacks.AddScript #systemPreNew "CloseRolloutFloater MLister.MatInspectorFloater" id:#MListerRollout -- do not localize
				--callBacks.AddScript #filePreOpen "CloseRolloutFloater MLister.MatInspectorFloater" id:#MListerRollout -- do not localize
				dialogUp = true
				--updateToolbarButtons()
			)
		) --end of matinspector rollout
	)  -- end of mat inspector setup
	
	on execute do	(
		--parseScene sceneMaterials
	
		local dialogPos, dialogSize
		dialogPos = [200,300]
		dialogSize = [800,300]
		try(closeRolloutFloater MLister.MatInspectorFloater) catch()
		MLister.MatInspectorFloater = newRolloutFloater "Material Lister 0.43" 700 700 100 100
		addRollout MLister.MatModeSetup MLister.MatInspectorFloater
		addRollout MLister.MatInspectorSetup MLister.MatInspectorFloater
		parseScene scenematerials
				refreshrollouts()
		dialogUp = true
	)
		
	on resized new_size do
	(
		MLister.matinspectorfloater.size = new_size
	)
	
	on closeDialogs do
	(
		try(closeRolloutFloater MLister.MatInspectorFloater) catch( print "error in Material Lister" )
		dialogUp = False
		gc()
		destroydialog MLister.matinspectorsetup 
	)
	on isChecked return
	(	
		dialogUp
	)
	
)--end macroscript
